/* PresetList.c generated by valac 0.42.3, the Vala compiler
 * generated from PresetList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <gee.h>


#define NOISE_TYPE_PRESET_LIST (noise_preset_list_get_type ())
#define NOISE_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PRESET_LIST, NoisePresetList))
#define NOISE_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PRESET_LIST, NoisePresetListClass))
#define NOISE_IS_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PRESET_LIST))
#define NOISE_IS_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PRESET_LIST))
#define NOISE_PRESET_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PRESET_LIST, NoisePresetListClass))

typedef struct _NoisePresetList NoisePresetList;
typedef struct _NoisePresetListClass NoisePresetListClass;
typedef struct _NoisePresetListPrivate NoisePresetListPrivate;
enum  {
	NOISE_PRESET_LIST_0_PROPERTY,
	NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY,
	NOISE_PRESET_LIST_NUM_PROPERTIES
};
static GParamSpec* noise_preset_list_properties[NOISE_PRESET_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL,
	NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL,
	NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL,
	NOISE_PRESET_LIST_NUM_SIGNALS
};
static guint noise_preset_list_signals[NOISE_PRESET_LIST_NUM_SIGNALS] = {0};

struct _NoisePresetList {
	GtkComboBox parent_instance;
	NoisePresetListPrivate * priv;
	NoiseEqualizerPreset* last_selected_preset;
};

struct _NoisePresetListClass {
	GtkComboBoxClass parent_class;
	void (*list_selection_change) (NoisePresetList* self);
};

struct _NoisePresetListPrivate {
	gint _ncustompresets;
	gboolean modifying_list;
	gboolean automatic_selected;
	GtkListStore* store;
};


static gint NoisePresetList_private_offset;
static gpointer noise_preset_list_parent_class = NULL;
static gchar* noise_preset_list_AUTOMATIC_MODE;
static gchar* noise_preset_list_AUTOMATIC_MODE = NULL;
static gchar* noise_preset_list_DELETE_PRESET;
static gchar* noise_preset_list_DELETE_PRESET = NULL;

GType noise_preset_list_get_type (void) G_GNUC_CONST;
#define NOISE_PRESET_LIST_SEPARATOR_NAME "<separator_item_unique_name>"
NoisePresetList* noise_preset_list_new (void);
NoisePresetList* noise_preset_list_construct (GType object_type);
static void noise_preset_list_set_ncustompresets (NoisePresetList* self,
                                           gint value);
static gboolean __lambda20_ (NoisePresetList* self,
                      GtkTreeModel* model,
                      GtkTreeIter* iter);
static gboolean ___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                        GtkTreeIter* iter,
                                                        gpointer self);
void noise_preset_list_list_selection_change (NoisePresetList* self);
static void _noise_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
void noise_preset_list_add_separator (NoisePresetList* self);
void noise_preset_list_add_preset (NoisePresetList* self,
                                   NoiseEqualizerPreset* ep);
static gint noise_preset_list_get_ncustompresets (NoisePresetList* self);
void noise_preset_list_remove_current_preset (NoisePresetList* self);
static void noise_preset_list_remove_separator_item (NoisePresetList* self,
                                              gint index);
void noise_preset_list_select_automatic_preset (NoisePresetList* self);
static void noise_preset_list_real_list_selection_change (NoisePresetList* self);
static void noise_preset_list_add_delete_preset_option (NoisePresetList* self);
static void noise_preset_list_remove_delete_option (NoisePresetList* self);
void noise_preset_list_select_preset (NoisePresetList* self,
                                      const gchar* preset_name);
NoiseEqualizerPreset* noise_preset_list_get_selected_preset (NoisePresetList* self);
GeeCollection* noise_preset_list_get_presets (NoisePresetList* self);
gboolean noise_preset_list_get_automatic_chosen (NoisePresetList* self);
static void noise_preset_list_finalize (GObject * obj);
static void _vala_noise_preset_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_preset_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_preset_list_get_instance_private (NoisePresetList* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePresetList_private_offset);
}


static gboolean
__lambda20_ (NoisePresetList* self,
             GtkTreeModel* model,
             GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gchar* content = NULL;
	gchar* _tmp0_;
	GtkTreeIter _tmp1_;
	const gchar* _tmp2_;
#line 65 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 65 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 66 "../src/Widgets/PresetList.vala"
	_tmp0_ = g_strdup ("");
#line 66 "../src/Widgets/PresetList.vala"
	content = _tmp0_;
#line 67 "../src/Widgets/PresetList.vala"
	_tmp1_ = *iter;
#line 67 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get (model, &_tmp1_, 1, &content, -1);
#line 69 "../src/Widgets/PresetList.vala"
	_tmp2_ = content;
#line 69 "../src/Widgets/PresetList.vala"
	result = g_strcmp0 (_tmp2_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 69 "../src/Widgets/PresetList.vala"
	_g_free0 (content);
#line 69 "../src/Widgets/PresetList.vala"
	return result;
#line 176 "PresetList.c"
}


static gboolean
___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                               GtkTreeIter* iter,
                                               gpointer self)
{
	gboolean result;
	result = __lambda20_ ((NoisePresetList*) self, model, iter);
#line 65 "../src/Widgets/PresetList.vala"
	return result;
#line 189 "PresetList.c"
}


static void
_noise_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 78 "../src/Widgets/PresetList.vala"
	noise_preset_list_list_selection_change ((NoisePresetList*) self);
#line 199 "PresetList.c"
}


NoisePresetList*
noise_preset_list_construct (GType object_type)
{
	NoisePresetList * self = NULL;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
#line 55 "../src/Widgets/PresetList.vala"
	self = (NoisePresetList*) g_object_new (object_type, NULL);
#line 56 "../src/Widgets/PresetList.vala"
	noise_preset_list_set_ncustompresets (self, 0);
#line 57 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 58 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = FALSE;
#line 60 "../src/Widgets/PresetList.vala"
	_tmp0_ = gtk_list_store_new (2, G_TYPE_OBJECT, G_TYPE_STRING, -1);
#line 60 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->priv->store);
#line 60 "../src/Widgets/PresetList.vala"
	self->priv->store = _tmp0_;
#line 62 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 62 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_model ((GtkComboBox*) self, (GtkTreeModel*) _tmp1_);
#line 63 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_id_column ((GtkComboBox*) self, 1);
#line 65 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_row_separator_func ((GtkComboBox*) self, ___lambda20__gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
#line 72 "../src/Widgets/PresetList.vala"
	_tmp2_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 72 "../src/Widgets/PresetList.vala"
	g_object_ref_sink (_tmp2_);
#line 72 "../src/Widgets/PresetList.vala"
	cell = _tmp2_;
#line 73 "../src/Widgets/PresetList.vala"
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 75 "../src/Widgets/PresetList.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, (GtkCellRenderer*) cell, TRUE);
#line 76 "../src/Widgets/PresetList.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, (GtkCellRenderer*) cell, "text", 1);
#line 78 "../src/Widgets/PresetList.vala"
	g_signal_connect_object ((GtkComboBox*) self, "changed", (GCallback) _noise_preset_list_list_selection_change_gtk_combo_box_changed, self, 0);
#line 80 "../src/Widgets/PresetList.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 82 "../src/Widgets/PresetList.vala"
	_tmp3_ = self->priv->store;
#line 82 "../src/Widgets/PresetList.vala"
	gtk_list_store_clear (_tmp3_);
#line 85 "../src/Widgets/PresetList.vala"
	_tmp4_ = self->priv->store;
#line 85 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp4_, &_tmp5_);
#line 85 "../src/Widgets/PresetList.vala"
	iter = _tmp5_;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp6_ = self->priv->store;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp7_ = iter;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp8_ = noise_preset_list_AUTOMATIC_MODE;
#line 86 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, NULL, 1, _tmp8_, -1);
#line 88 "../src/Widgets/PresetList.vala"
	noise_preset_list_add_separator (self);
#line 55 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (cell);
#line 55 "../src/Widgets/PresetList.vala"
	return self;
#line 280 "PresetList.c"
}


NoisePresetList*
noise_preset_list_new (void)
{
#line 55 "../src/Widgets/PresetList.vala"
	return noise_preset_list_construct (NOISE_TYPE_PRESET_LIST);
#line 289 "PresetList.c"
}


void
noise_preset_list_add_separator (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
#line 91 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->store;
#line 93 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp0_, &_tmp1_);
#line 93 "../src/Widgets/PresetList.vala"
	iter = _tmp1_;
#line 94 "../src/Widgets/PresetList.vala"
	_tmp2_ = self->priv->store;
#line 94 "../src/Widgets/PresetList.vala"
	_tmp3_ = iter;
#line 94 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp2_, &_tmp3_, 0, NULL, 1, NOISE_PRESET_LIST_SEPARATOR_NAME, -1);
#line 315 "PresetList.c"
}


void
noise_preset_list_add_preset (NoisePresetList* self,
                              NoiseEqualizerPreset* ep)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeIter _tmp10_;
#line 97 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Widgets/PresetList.vala"
	g_return_if_fail (ep != NULL);
#line 98 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = TRUE;
#line 100 "../src/Widgets/PresetList.vala"
	_tmp0_ = noise_equalizer_preset_get_is_default (ep);
#line 100 "../src/Widgets/PresetList.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/Widgets/PresetList.vala"
	if (!_tmp1_) {
#line 345 "PresetList.c"
		gint _tmp2_;
		gint _tmp3_;
#line 102 "../src/Widgets/PresetList.vala"
		_tmp2_ = self->priv->_ncustompresets;
#line 102 "../src/Widgets/PresetList.vala"
		if (_tmp2_ < 1) {
#line 103 "../src/Widgets/PresetList.vala"
			noise_preset_list_add_separator (self);
#line 354 "PresetList.c"
		}
#line 106 "../src/Widgets/PresetList.vala"
		_tmp3_ = self->priv->_ncustompresets;
#line 106 "../src/Widgets/PresetList.vala"
		noise_preset_list_set_ncustompresets (self, _tmp3_ + 1);
#line 360 "PresetList.c"
	}
#line 110 "../src/Widgets/PresetList.vala"
	_tmp4_ = self->priv->store;
#line 110 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp4_, &_tmp5_);
#line 110 "../src/Widgets/PresetList.vala"
	iter = _tmp5_;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp6_ = self->priv->store;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp7_ = iter;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp8_ = noise_equalizer_preset_get_name (ep);
#line 111 "../src/Widgets/PresetList.vala"
	_tmp9_ = _tmp8_;
#line 111 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, ep, 1, _tmp9_, -1);
#line 113 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 114 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = FALSE;
#line 116 "../src/Widgets/PresetList.vala"
	_tmp10_ = iter;
#line 116 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp10_);
#line 386 "PresetList.c"
}


void
noise_preset_list_remove_current_preset (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	gint _tmp22_;
#line 119 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = TRUE;
#line 399 "PresetList.c"
	{
		gint i = 0;
#line 123 "../src/Widgets/PresetList.vala"
		i = 0;
#line 404 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 123 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 123 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 411 "PresetList.c"
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				GObject* o = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				GObject* _tmp13_;
#line 123 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 427 "PresetList.c"
					gint _tmp1_;
#line 123 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 123 "../src/Widgets/PresetList.vala"
					i = _tmp1_ + 1;
#line 433 "PresetList.c"
				}
#line 123 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp3_ = i;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 123 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
#line 123 "../src/Widgets/PresetList.vala"
				iter = _tmp6_;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 123 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 123 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 123 "../src/Widgets/PresetList.vala"
					break;
#line 457 "PresetList.c"
				}
#line 125 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 125 "../src/Widgets/PresetList.vala"
				_tmp10_ = iter;
#line 125 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &o, -1);
#line 127 "../src/Widgets/PresetList.vala"
				_tmp13_ = o;
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp13_ != NULL) {
#line 469 "PresetList.c"
					GObject* _tmp14_;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp14_ = o;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, NOISE_TYPE_EQUALIZER_PRESET);
#line 475 "PresetList.c"
				} else {
#line 127 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 479 "PresetList.c"
				}
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 483 "PresetList.c"
					GObject* _tmp15_;
					NoiseEqualizerPreset* _tmp16_;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp15_ = o;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp16_ = self->last_selected_preset;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset) == _tmp16_;
#line 492 "PresetList.c"
				} else {
#line 127 "../src/Widgets/PresetList.vala"
					_tmp11_ = FALSE;
#line 496 "PresetList.c"
				}
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp11_) {
#line 500 "PresetList.c"
					GObject* _tmp17_;
					gboolean _tmp18_;
					gboolean _tmp19_;
#line 128 "../src/Widgets/PresetList.vala"
					_tmp17_ = o;
#line 128 "../src/Widgets/PresetList.vala"
					_tmp18_ = noise_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset));
#line 128 "../src/Widgets/PresetList.vala"
					_tmp19_ = _tmp18_;
#line 128 "../src/Widgets/PresetList.vala"
					if (!_tmp19_) {
#line 512 "PresetList.c"
						gint _tmp20_;
						GtkListStore* _tmp21_;
#line 129 "../src/Widgets/PresetList.vala"
						_tmp20_ = self->priv->_ncustompresets;
#line 129 "../src/Widgets/PresetList.vala"
						noise_preset_list_set_ncustompresets (self, _tmp20_ - 1);
#line 131 "../src/Widgets/PresetList.vala"
						_tmp21_ = self->priv->store;
#line 131 "../src/Widgets/PresetList.vala"
						gtk_list_store_remove (_tmp21_, &iter);
#line 135 "../src/Widgets/PresetList.vala"
						_g_object_unref0 (o);
#line 135 "../src/Widgets/PresetList.vala"
						break;
#line 527 "PresetList.c"
					}
				}
#line 123 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 532 "PresetList.c"
			}
		}
	}
#line 141 "../src/Widgets/PresetList.vala"
	_tmp22_ = self->priv->_ncustompresets;
#line 141 "../src/Widgets/PresetList.vala"
	if (_tmp22_ < 1) {
#line 142 "../src/Widgets/PresetList.vala"
		noise_preset_list_remove_separator_item (self, -1);
#line 542 "PresetList.c"
	}
#line 145 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 147 "../src/Widgets/PresetList.vala"
	noise_preset_list_select_automatic_preset (self);
#line 548 "PresetList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 162 "../src/Widgets/PresetList.vala"
	return self ? g_object_ref (self) : NULL;
#line 557 "PresetList.c"
}


static void
noise_preset_list_real_list_selection_change (NoisePresetList* self)
{
	gboolean _tmp0_;
	GtkTreeIter it = {0};
	GtkTreeIter _tmp1_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
	gchar* option = NULL;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
#line 151 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->modifying_list;
#line 151 "../src/Widgets/PresetList.vala"
	if (_tmp0_) {
#line 152 "../src/Widgets/PresetList.vala"
		return;
#line 583 "PresetList.c"
	}
#line 156 "../src/Widgets/PresetList.vala"
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp1_);
#line 156 "../src/Widgets/PresetList.vala"
	it = _tmp1_;
#line 159 "../src/Widgets/PresetList.vala"
	_tmp2_ = self->priv->store;
#line 159 "../src/Widgets/PresetList.vala"
	_tmp3_ = it;
#line 159 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp2_, &_tmp3_, 0, &o, -1);
#line 161 "../src/Widgets/PresetList.vala"
	_tmp5_ = o;
#line 161 "../src/Widgets/PresetList.vala"
	if (_tmp5_ != NULL) {
#line 599 "PresetList.c"
		GObject* _tmp6_;
#line 161 "../src/Widgets/PresetList.vala"
		_tmp6_ = o;
#line 161 "../src/Widgets/PresetList.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, NOISE_TYPE_EQUALIZER_PRESET);
#line 605 "PresetList.c"
	} else {
#line 161 "../src/Widgets/PresetList.vala"
		_tmp4_ = FALSE;
#line 609 "PresetList.c"
	}
#line 161 "../src/Widgets/PresetList.vala"
	if (_tmp4_) {
#line 613 "PresetList.c"
		GObject* _tmp7_;
		NoiseEqualizerPreset* _tmp8_;
		GObject* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		GObject* _tmp12_;
#line 162 "../src/Widgets/PresetList.vala"
		_tmp7_ = o;
#line 162 "../src/Widgets/PresetList.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp7_) : NULL);
#line 162 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (self->last_selected_preset);
#line 162 "../src/Widgets/PresetList.vala"
		self->last_selected_preset = _tmp8_;
#line 164 "../src/Widgets/PresetList.vala"
		_tmp9_ = o;
#line 164 "../src/Widgets/PresetList.vala"
		_tmp10_ = noise_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp9_) : NULL);
#line 164 "../src/Widgets/PresetList.vala"
		_tmp11_ = _tmp10_;
#line 164 "../src/Widgets/PresetList.vala"
		if (!_tmp11_) {
#line 165 "../src/Widgets/PresetList.vala"
			noise_preset_list_add_delete_preset_option (self);
#line 638 "PresetList.c"
		} else {
#line 167 "../src/Widgets/PresetList.vala"
			noise_preset_list_remove_delete_option (self);
#line 642 "PresetList.c"
		}
#line 170 "../src/Widgets/PresetList.vala"
		self->priv->automatic_selected = FALSE;
#line 171 "../src/Widgets/PresetList.vala"
		_tmp12_ = o;
#line 171 "../src/Widgets/PresetList.vala"
		g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp12_) : NULL);
#line 172 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 172 "../src/Widgets/PresetList.vala"
		return;
#line 654 "PresetList.c"
	}
#line 176 "../src/Widgets/PresetList.vala"
	_tmp13_ = self->priv->store;
#line 176 "../src/Widgets/PresetList.vala"
	_tmp14_ = it;
#line 176 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp13_, &_tmp14_, 1, &option, -1);
#line 178 "../src/Widgets/PresetList.vala"
	_tmp15_ = option;
#line 178 "../src/Widgets/PresetList.vala"
	_tmp16_ = noise_preset_list_AUTOMATIC_MODE;
#line 178 "../src/Widgets/PresetList.vala"
	if (g_strcmp0 (_tmp15_, _tmp16_) == 0) {
#line 179 "../src/Widgets/PresetList.vala"
		self->priv->automatic_selected = TRUE;
#line 180 "../src/Widgets/PresetList.vala"
		noise_preset_list_remove_delete_option (self);
#line 181 "../src/Widgets/PresetList.vala"
		g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
#line 674 "PresetList.c"
	} else {
		const gchar* _tmp17_;
		const gchar* _tmp18_;
#line 182 "../src/Widgets/PresetList.vala"
		_tmp17_ = option;
#line 182 "../src/Widgets/PresetList.vala"
		_tmp18_ = noise_preset_list_DELETE_PRESET;
#line 182 "../src/Widgets/PresetList.vala"
		if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 183 "../src/Widgets/PresetList.vala"
			g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL], 0);
#line 686 "PresetList.c"
		}
	}
#line 150 "../src/Widgets/PresetList.vala"
	_g_free0 (option);
#line 150 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 693 "PresetList.c"
}


void
noise_preset_list_list_selection_change (NoisePresetList* self)
{
#line 150 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Widgets/PresetList.vala"
	NOISE_PRESET_LIST_GET_CLASS (self)->list_selection_change (self);
#line 704 "PresetList.c"
}


void
noise_preset_list_select_automatic_preset (NoisePresetList* self)
{
#line 187 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = TRUE;
#line 189 "../src/Widgets/PresetList.vala"
	g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
#line 190 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_active ((GtkComboBox*) self, 0);
#line 719 "PresetList.c"
}


void
noise_preset_list_select_preset (NoisePresetList* self,
                                 const gchar* preset_name)
{
	gboolean _tmp0_ = FALSE;
#line 193 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Widgets/PresetList.vala"
	if (preset_name == NULL) {
#line 195 "../src/Widgets/PresetList.vala"
		_tmp0_ = TRUE;
#line 734 "PresetList.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 195 "../src/Widgets/PresetList.vala"
		_tmp1_ = strlen (preset_name);
#line 195 "../src/Widgets/PresetList.vala"
		_tmp2_ = _tmp1_;
#line 195 "../src/Widgets/PresetList.vala"
		_tmp0_ = _tmp2_ < 1;
#line 744 "PresetList.c"
	}
#line 195 "../src/Widgets/PresetList.vala"
	if (!_tmp0_) {
#line 748 "PresetList.c"
		GtkTreeIter iter = {0};
		{
			gint i = 0;
#line 197 "../src/Widgets/PresetList.vala"
			i = 0;
#line 754 "PresetList.c"
			{
				gboolean _tmp3_ = FALSE;
#line 197 "../src/Widgets/PresetList.vala"
				_tmp3_ = TRUE;
#line 197 "../src/Widgets/PresetList.vala"
				while (TRUE) {
#line 761 "PresetList.c"
					GtkListStore* _tmp5_;
					gint _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					GtkTreeIter _tmp9_ = {0};
					gboolean _tmp10_;
					gboolean _tmp11_;
					GObject* o = NULL;
					GtkListStore* _tmp12_;
					GtkTreeIter _tmp13_;
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_ = FALSE;
					GObject* _tmp16_;
#line 197 "../src/Widgets/PresetList.vala"
					if (!_tmp3_) {
#line 777 "PresetList.c"
						gint _tmp4_;
#line 197 "../src/Widgets/PresetList.vala"
						_tmp4_ = i;
#line 197 "../src/Widgets/PresetList.vala"
						i = _tmp4_ + 1;
#line 783 "PresetList.c"
					}
#line 197 "../src/Widgets/PresetList.vala"
					_tmp3_ = FALSE;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp5_ = self->priv->store;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp6_ = i;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 197 "../src/Widgets/PresetList.vala"
					_tmp8_ = _tmp7_;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp10_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp5_, &_tmp9_, _tmp8_);
#line 197 "../src/Widgets/PresetList.vala"
					iter = _tmp9_;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp11_ = !_tmp10_;
#line 197 "../src/Widgets/PresetList.vala"
					_g_free0 (_tmp8_);
#line 197 "../src/Widgets/PresetList.vala"
					if (_tmp11_) {
#line 197 "../src/Widgets/PresetList.vala"
						break;
#line 807 "PresetList.c"
					}
#line 199 "../src/Widgets/PresetList.vala"
					_tmp12_ = self->priv->store;
#line 199 "../src/Widgets/PresetList.vala"
					_tmp13_ = iter;
#line 199 "../src/Widgets/PresetList.vala"
					gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 0, &o, -1);
#line 201 "../src/Widgets/PresetList.vala"
					_tmp16_ = o;
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp16_ != NULL) {
#line 819 "PresetList.c"
						GObject* _tmp17_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp17_ = o;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, NOISE_TYPE_EQUALIZER_PRESET);
#line 825 "PresetList.c"
					} else {
#line 201 "../src/Widgets/PresetList.vala"
						_tmp15_ = FALSE;
#line 829 "PresetList.c"
					}
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp15_) {
#line 833 "PresetList.c"
						GObject* _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp18_ = o;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp19_ = noise_equalizer_preset_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp18_) : NULL);
#line 201 "../src/Widgets/PresetList.vala"
						_tmp20_ = _tmp19_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp14_ = g_strcmp0 (_tmp20_, preset_name) == 0;
#line 845 "PresetList.c"
					} else {
#line 201 "../src/Widgets/PresetList.vala"
						_tmp14_ = FALSE;
#line 849 "PresetList.c"
					}
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp14_) {
#line 853 "PresetList.c"
						GtkTreeIter _tmp21_;
						GObject* _tmp22_;
#line 202 "../src/Widgets/PresetList.vala"
						_tmp21_ = iter;
#line 202 "../src/Widgets/PresetList.vala"
						gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp21_);
#line 203 "../src/Widgets/PresetList.vala"
						self->priv->automatic_selected = FALSE;
#line 204 "../src/Widgets/PresetList.vala"
						_tmp22_ = o;
#line 204 "../src/Widgets/PresetList.vala"
						g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp22_) : NULL);
#line 205 "../src/Widgets/PresetList.vala"
						_g_object_unref0 (o);
#line 205 "../src/Widgets/PresetList.vala"
						return;
#line 870 "PresetList.c"
					}
#line 197 "../src/Widgets/PresetList.vala"
					_g_object_unref0 (o);
#line 874 "PresetList.c"
				}
			}
		}
	}
#line 210 "../src/Widgets/PresetList.vala"
	noise_preset_list_select_automatic_preset (self);
#line 881 "PresetList.c"
}


NoiseEqualizerPreset*
noise_preset_list_get_selected_preset (NoisePresetList* self)
{
	NoiseEqualizerPreset* result = NULL;
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	gboolean _tmp3_ = FALSE;
	GObject* _tmp4_;
#line 213 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "../src/Widgets/PresetList.vala"
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
#line 215 "../src/Widgets/PresetList.vala"
	it = _tmp0_;
#line 218 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 218 "../src/Widgets/PresetList.vala"
	_tmp2_ = it;
#line 218 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &o, -1);
#line 220 "../src/Widgets/PresetList.vala"
	_tmp4_ = o;
#line 220 "../src/Widgets/PresetList.vala"
	if (_tmp4_ != NULL) {
#line 912 "PresetList.c"
		GObject* _tmp5_;
#line 220 "../src/Widgets/PresetList.vala"
		_tmp5_ = o;
#line 220 "../src/Widgets/PresetList.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, NOISE_TYPE_EQUALIZER_PRESET);
#line 918 "PresetList.c"
	} else {
#line 220 "../src/Widgets/PresetList.vala"
		_tmp3_ = FALSE;
#line 922 "PresetList.c"
	}
#line 220 "../src/Widgets/PresetList.vala"
	if (_tmp3_) {
#line 926 "PresetList.c"
		GObject* _tmp6_;
		NoiseEqualizerPreset* _tmp7_;
#line 221 "../src/Widgets/PresetList.vala"
		_tmp6_ = o;
#line 221 "../src/Widgets/PresetList.vala"
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp6_) : NULL);
#line 221 "../src/Widgets/PresetList.vala"
		result = _tmp7_;
#line 221 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 221 "../src/Widgets/PresetList.vala"
		return result;
#line 939 "PresetList.c"
	} else {
#line 223 "../src/Widgets/PresetList.vala"
		result = NULL;
#line 223 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 223 "../src/Widgets/PresetList.vala"
		return result;
#line 947 "PresetList.c"
	}
#line 213 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 951 "PresetList.c"
}


GeeCollection*
noise_preset_list_get_presets (NoisePresetList* self)
{
	GeeCollection* result = NULL;
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GtkTreeIter iter = {0};
#line 227 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../src/Widgets/PresetList.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 229 "../src/Widgets/PresetList.vala"
	rv = _tmp0_;
#line 968 "PresetList.c"
	{
		gint i = 0;
#line 232 "../src/Widgets/PresetList.vala"
		i = 0;
#line 973 "PresetList.c"
		{
			gboolean _tmp1_ = FALSE;
#line 232 "../src/Widgets/PresetList.vala"
			_tmp1_ = TRUE;
#line 232 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 980 "PresetList.c"
				GtkListStore* _tmp3_;
				gint _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				GtkTreeIter _tmp7_ = {0};
				gboolean _tmp8_;
				gboolean _tmp9_;
				GObject* o = NULL;
				GtkListStore* _tmp10_;
				GtkTreeIter _tmp11_;
				gboolean _tmp12_ = FALSE;
				GObject* _tmp13_;
#line 232 "../src/Widgets/PresetList.vala"
				if (!_tmp1_) {
#line 995 "PresetList.c"
					gint _tmp2_;
#line 232 "../src/Widgets/PresetList.vala"
					_tmp2_ = i;
#line 232 "../src/Widgets/PresetList.vala"
					i = _tmp2_ + 1;
#line 1001 "PresetList.c"
				}
#line 232 "../src/Widgets/PresetList.vala"
				_tmp1_ = FALSE;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp3_ = self->priv->store;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp4_ = i;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 232 "../src/Widgets/PresetList.vala"
				_tmp6_ = _tmp5_;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp8_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp3_, &_tmp7_, _tmp6_);
#line 232 "../src/Widgets/PresetList.vala"
				iter = _tmp7_;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp9_ = !_tmp8_;
#line 232 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp6_);
#line 232 "../src/Widgets/PresetList.vala"
				if (_tmp9_) {
#line 232 "../src/Widgets/PresetList.vala"
					break;
#line 1025 "PresetList.c"
				}
#line 234 "../src/Widgets/PresetList.vala"
				_tmp10_ = self->priv->store;
#line 234 "../src/Widgets/PresetList.vala"
				_tmp11_ = iter;
#line 234 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 0, &o, -1);
#line 236 "../src/Widgets/PresetList.vala"
				_tmp13_ = o;
#line 236 "../src/Widgets/PresetList.vala"
				if (_tmp13_ != NULL) {
#line 1037 "PresetList.c"
					GObject* _tmp14_;
#line 236 "../src/Widgets/PresetList.vala"
					_tmp14_ = o;
#line 236 "../src/Widgets/PresetList.vala"
					_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, NOISE_TYPE_EQUALIZER_PRESET);
#line 1043 "PresetList.c"
				} else {
#line 236 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 1047 "PresetList.c"
				}
#line 236 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 1051 "PresetList.c"
					GeeLinkedList* _tmp15_;
					GObject* _tmp16_;
#line 237 "../src/Widgets/PresetList.vala"
					_tmp15_ = rv;
#line 237 "../src/Widgets/PresetList.vala"
					_tmp16_ = o;
#line 237 "../src/Widgets/PresetList.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp16_) : NULL);
#line 1060 "PresetList.c"
				}
#line 232 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 1064 "PresetList.c"
			}
		}
	}
#line 241 "../src/Widgets/PresetList.vala"
	result = (GeeCollection*) rv;
#line 241 "../src/Widgets/PresetList.vala"
	return result;
#line 1072 "PresetList.c"
}


static void
noise_preset_list_remove_delete_option (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
#line 244 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 1082 "PresetList.c"
	{
		gint i = 0;
#line 246 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1087 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 246 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 246 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1094 "PresetList.c"
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
#line 246 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 1109 "PresetList.c"
					gint _tmp1_;
#line 246 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 246 "../src/Widgets/PresetList.vala"
					i = _tmp1_ + 1;
#line 1115 "PresetList.c"
				}
#line 246 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp3_ = i;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 246 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
#line 246 "../src/Widgets/PresetList.vala"
				iter = _tmp6_;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 246 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 246 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 246 "../src/Widgets/PresetList.vala"
					break;
#line 1139 "PresetList.c"
				}
#line 248 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 248 "../src/Widgets/PresetList.vala"
				_tmp10_ = iter;
#line 248 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &text, -1);
#line 250 "../src/Widgets/PresetList.vala"
				_tmp12_ = text;
#line 250 "../src/Widgets/PresetList.vala"
				if (_tmp12_ != NULL) {
#line 1151 "PresetList.c"
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp13_ = text;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp14_ = noise_preset_list_DELETE_PRESET;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp11_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 1160 "PresetList.c"
				} else {
#line 250 "../src/Widgets/PresetList.vala"
					_tmp11_ = FALSE;
#line 1164 "PresetList.c"
				}
#line 250 "../src/Widgets/PresetList.vala"
				if (_tmp11_) {
#line 1168 "PresetList.c"
					GtkListStore* _tmp15_;
#line 252 "../src/Widgets/PresetList.vala"
					_tmp15_ = self->priv->store;
#line 252 "../src/Widgets/PresetList.vala"
					gtk_list_store_remove (_tmp15_, &iter);
#line 257 "../src/Widgets/PresetList.vala"
					noise_preset_list_remove_separator_item (self, 1);
#line 1176 "PresetList.c"
				}
#line 246 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1180 "PresetList.c"
			}
		}
	}
}


static void
noise_preset_list_remove_separator_item (NoisePresetList* self,
                                         gint index)
{
	gint count = 0;
	gint nitems = 0;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
#line 262 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/Widgets/PresetList.vala"
	count = 0;
#line 263 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->store;
#line 263 "../src/Widgets/PresetList.vala"
	nitems = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp0_, NULL);
#line 1203 "PresetList.c"
	{
		gint i = 0;
		gint _tmp1_;
#line 266 "../src/Widgets/PresetList.vala"
		_tmp1_ = nitems;
#line 266 "../src/Widgets/PresetList.vala"
		i = _tmp1_ - 1;
#line 1211 "PresetList.c"
		{
			gboolean _tmp2_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
			_tmp2_ = TRUE;
#line 266 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1218 "PresetList.c"
				GtkListStore* _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				GtkTreeIter _tmp8_ = {0};
				gboolean _tmp9_;
				gboolean _tmp10_;
				gint _tmp11_;
				gchar* text = NULL;
				GtkListStore* _tmp12_;
				GtkTreeIter _tmp13_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				gboolean _tmp16_ = FALSE;
				gint _tmp17_;
				gint _tmp18_;
#line 266 "../src/Widgets/PresetList.vala"
				if (!_tmp2_) {
#line 1237 "PresetList.c"
					gint _tmp3_;
#line 266 "../src/Widgets/PresetList.vala"
					_tmp3_ = i;
#line 266 "../src/Widgets/PresetList.vala"
					i = _tmp3_ - 1;
#line 1243 "PresetList.c"
				}
#line 266 "../src/Widgets/PresetList.vala"
				_tmp2_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp4_ = self->priv->store;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp5_ = i;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 266 "../src/Widgets/PresetList.vala"
				_tmp7_ = _tmp6_;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp9_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp4_, &_tmp8_, _tmp7_);
#line 266 "../src/Widgets/PresetList.vala"
				iter = _tmp8_;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp10_ = !_tmp9_;
#line 266 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp7_);
#line 266 "../src/Widgets/PresetList.vala"
				if (_tmp10_) {
#line 266 "../src/Widgets/PresetList.vala"
					break;
#line 1267 "PresetList.c"
				}
#line 267 "../src/Widgets/PresetList.vala"
				_tmp11_ = count;
#line 267 "../src/Widgets/PresetList.vala"
				count = _tmp11_ + 1;
#line 269 "../src/Widgets/PresetList.vala"
				_tmp12_ = self->priv->store;
#line 269 "../src/Widgets/PresetList.vala"
				_tmp13_ = iter;
#line 269 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 1, &text, -1);
#line 271 "../src/Widgets/PresetList.vala"
				_tmp17_ = nitems;
#line 271 "../src/Widgets/PresetList.vala"
				_tmp18_ = count;
#line 271 "../src/Widgets/PresetList.vala"
				if ((_tmp17_ - index) == _tmp18_) {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp16_ = TRUE;
#line 1287 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp16_ = index == -1;
#line 1291 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp16_) {
#line 1295 "PresetList.c"
					const gchar* _tmp19_;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp19_ = text;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp15_ = _tmp19_ != NULL;
#line 1301 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp15_ = FALSE;
#line 1305 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp15_) {
#line 1309 "PresetList.c"
					const gchar* _tmp20_;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp20_ = text;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp14_ = g_strcmp0 (_tmp20_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 1315 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp14_ = FALSE;
#line 1319 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp14_) {
#line 1323 "PresetList.c"
					GtkListStore* _tmp21_;
#line 273 "../src/Widgets/PresetList.vala"
					_tmp21_ = self->priv->store;
#line 273 "../src/Widgets/PresetList.vala"
					gtk_list_store_remove (_tmp21_, &iter);
#line 277 "../src/Widgets/PresetList.vala"
					_g_free0 (text);
#line 277 "../src/Widgets/PresetList.vala"
					break;
#line 1333 "PresetList.c"
				}
#line 266 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1337 "PresetList.c"
			}
		}
	}
}


static void
noise_preset_list_add_delete_preset_option (NoisePresetList* self)
{
	gboolean already_added = FALSE;
	GtkTreeIter last_iter = {0};
	GtkTreeIter new_iter = {0};
	gboolean _tmp21_;
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_;
	GtkTreeIter _tmp24_ = {0};
	GtkListStore* _tmp25_;
	GtkTreeIter _tmp26_;
	const gchar* _tmp27_;
	GtkTreeIter _tmp28_;
	GtkListStore* _tmp29_;
	GtkTreeIter _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
#line 282 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Widgets/PresetList.vala"
	already_added = FALSE;
#line 1367 "PresetList.c"
	{
		gint i = 0;
#line 286 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1372 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 286 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 286 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1379 "PresetList.c"
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
#line 286 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 1394 "PresetList.c"
					gint _tmp1_;
#line 286 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 286 "../src/Widgets/PresetList.vala"
					i = _tmp1_ + 1;
#line 1400 "PresetList.c"
				}
#line 286 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp3_ = i;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 286 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
#line 286 "../src/Widgets/PresetList.vala"
				last_iter = _tmp6_;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 286 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 286 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 286 "../src/Widgets/PresetList.vala"
					break;
#line 1424 "PresetList.c"
				}
#line 288 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 288 "../src/Widgets/PresetList.vala"
				_tmp10_ = last_iter;
#line 288 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &text, -1);
#line 290 "../src/Widgets/PresetList.vala"
				_tmp12_ = text;
#line 290 "../src/Widgets/PresetList.vala"
				if (_tmp12_ != NULL) {
#line 1436 "PresetList.c"
					const gchar* _tmp13_;
#line 290 "../src/Widgets/PresetList.vala"
					_tmp13_ = text;
#line 290 "../src/Widgets/PresetList.vala"
					_tmp11_ = g_strcmp0 (_tmp13_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 1442 "PresetList.c"
				} else {
#line 290 "../src/Widgets/PresetList.vala"
					_tmp11_ = FALSE;
#line 1446 "PresetList.c"
				}
#line 290 "../src/Widgets/PresetList.vala"
				if (_tmp11_) {
#line 1450 "PresetList.c"
					GtkTreeIter _tmp14_;
					GtkListStore* _tmp15_;
					gboolean _tmp16_;
#line 291 "../src/Widgets/PresetList.vala"
					_tmp14_ = last_iter;
#line 291 "../src/Widgets/PresetList.vala"
					new_iter = _tmp14_;
#line 293 "../src/Widgets/PresetList.vala"
					_tmp15_ = self->priv->store;
#line 293 "../src/Widgets/PresetList.vala"
					_tmp16_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp15_, &new_iter);
#line 293 "../src/Widgets/PresetList.vala"
					if (_tmp16_) {
#line 1464 "PresetList.c"
						GtkListStore* _tmp17_;
						GtkTreeIter _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
#line 294 "../src/Widgets/PresetList.vala"
						_tmp17_ = self->priv->store;
#line 294 "../src/Widgets/PresetList.vala"
						_tmp18_ = new_iter;
#line 294 "../src/Widgets/PresetList.vala"
						gtk_tree_model_get ((GtkTreeModel*) _tmp17_, &_tmp18_, 1, &text, -1);
#line 295 "../src/Widgets/PresetList.vala"
						_tmp19_ = text;
#line 295 "../src/Widgets/PresetList.vala"
						_tmp20_ = noise_preset_list_DELETE_PRESET;
#line 295 "../src/Widgets/PresetList.vala"
						already_added = g_strcmp0 (_tmp19_, _tmp20_) == 0;
#line 1481 "PresetList.c"
					}
#line 298 "../src/Widgets/PresetList.vala"
					_g_free0 (text);
#line 298 "../src/Widgets/PresetList.vala"
					break;
#line 1487 "PresetList.c"
				}
#line 286 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1491 "PresetList.c"
			}
		}
	}
#line 302 "../src/Widgets/PresetList.vala"
	_tmp21_ = already_added;
#line 302 "../src/Widgets/PresetList.vala"
	if (_tmp21_) {
#line 303 "../src/Widgets/PresetList.vala"
		return;
#line 1501 "PresetList.c"
	}
#line 307 "../src/Widgets/PresetList.vala"
	_tmp22_ = self->priv->store;
#line 307 "../src/Widgets/PresetList.vala"
	_tmp23_ = last_iter;
#line 307 "../src/Widgets/PresetList.vala"
	gtk_list_store_insert_after (_tmp22_, &_tmp24_, &_tmp23_);
#line 307 "../src/Widgets/PresetList.vala"
	new_iter = _tmp24_;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp25_ = self->priv->store;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp26_ = new_iter;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp27_ = noise_preset_list_DELETE_PRESET;
#line 308 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp25_, &_tmp26_, 0, NULL, 1, _tmp27_, -1);
#line 310 "../src/Widgets/PresetList.vala"
	_tmp28_ = new_iter;
#line 310 "../src/Widgets/PresetList.vala"
	last_iter = _tmp28_;
#line 313 "../src/Widgets/PresetList.vala"
	_tmp29_ = self->priv->store;
#line 313 "../src/Widgets/PresetList.vala"
	_tmp30_ = last_iter;
#line 313 "../src/Widgets/PresetList.vala"
	gtk_list_store_insert_after (_tmp29_, &_tmp31_, &_tmp30_);
#line 313 "../src/Widgets/PresetList.vala"
	new_iter = _tmp31_;
#line 314 "../src/Widgets/PresetList.vala"
	_tmp32_ = self->priv->store;
#line 314 "../src/Widgets/PresetList.vala"
	_tmp33_ = new_iter;
#line 314 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, NULL, 1, NOISE_PRESET_LIST_SEPARATOR_NAME, -1);
#line 1537 "PresetList.c"
}


gboolean
noise_preset_list_get_automatic_chosen (NoisePresetList* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 35 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->automatic_selected;
#line 36 "../src/Widgets/PresetList.vala"
	result = _tmp0_;
#line 36 "../src/Widgets/PresetList.vala"
	return result;
#line 1554 "PresetList.c"
}


static gint
noise_preset_list_get_ncustompresets (NoisePresetList* self)
{
	gint result;
	gint _tmp0_;
#line 42 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->_ncustompresets;
#line 42 "../src/Widgets/PresetList.vala"
	result = _tmp0_;
#line 42 "../src/Widgets/PresetList.vala"
	return result;
#line 1571 "PresetList.c"
}


static void
noise_preset_list_set_ncustompresets (NoisePresetList* self,
                                      gint value)
{
#line 42 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Widgets/PresetList.vala"
	self->priv->_ncustompresets = value;
#line 1583 "PresetList.c"
}


static void
noise_preset_list_class_init (NoisePresetListClass * klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/PresetList.vala"
	g_type_class_adjust_private_offset (klass, &NoisePresetList_private_offset);
#line 29 "../src/Widgets/PresetList.vala"
	((NoisePresetListClass *) klass)->list_selection_change = (void (*) (NoisePresetList *)) noise_preset_list_real_list_selection_change;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_preset_list_get_property;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_preset_list_set_property;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_preset_list_finalize;
#line 29 "../src/Widgets/PresetList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY, noise_preset_list_properties[NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY] = g_param_spec_boolean ("automatic-chosen", "automatic-chosen", "automatic-chosen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL] = g_signal_new ("preset-selected", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_EQUALIZER_PRESET);
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL] = g_signal_new ("automatic-preset-chosen", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_signals[NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL] = g_signal_new ("delete-preset-chosen", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 52 "../src/Widgets/PresetList.vala"
	_tmp0_ = g_strdup (_ ("Automatic"));
#line 52 "../src/Widgets/PresetList.vala"
	noise_preset_list_AUTOMATIC_MODE = _tmp0_;
#line 53 "../src/Widgets/PresetList.vala"
	_tmp1_ = g_strdup (_ ("Delete Current"));
#line 53 "../src/Widgets/PresetList.vala"
	noise_preset_list_DELETE_PRESET = _tmp1_;
#line 1620 "PresetList.c"
}


static void
noise_preset_list_instance_init (NoisePresetList * self)
{
#line 29 "../src/Widgets/PresetList.vala"
	self->priv = noise_preset_list_get_instance_private (self);
#line 1629 "PresetList.c"
}


static void
noise_preset_list_finalize (GObject * obj)
{
	NoisePresetList * self;
#line 29 "../src/Widgets/PresetList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PRESET_LIST, NoisePresetList);
#line 40 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->last_selected_preset);
#line 47 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->priv->store);
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (noise_preset_list_parent_class)->finalize (obj);
#line 1645 "PresetList.c"
}


GType
noise_preset_list_get_type (void)
{
	static volatile gsize noise_preset_list_type_id__volatile = 0;
	if (g_once_init_enter (&noise_preset_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePresetListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_preset_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePresetList), 0, (GInstanceInitFunc) noise_preset_list_instance_init, NULL };
		GType noise_preset_list_type_id;
		noise_preset_list_type_id = g_type_register_static (gtk_combo_box_get_type (), "NoisePresetList", &g_define_type_info, 0);
		NoisePresetList_private_offset = g_type_add_instance_private (noise_preset_list_type_id, sizeof (NoisePresetListPrivate));
		g_once_init_leave (&noise_preset_list_type_id__volatile, noise_preset_list_type_id);
	}
	return noise_preset_list_type_id__volatile;
}


static void
_vala_noise_preset_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PRESET_LIST, NoisePresetList);
#line 29 "../src/Widgets/PresetList.vala"
	switch (property_id) {
#line 29 "../src/Widgets/PresetList.vala"
		case NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY:
#line 29 "../src/Widgets/PresetList.vala"
		g_value_set_boolean (value, noise_preset_list_get_automatic_chosen (self));
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1680 "PresetList.c"
		default:
#line 29 "../src/Widgets/PresetList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1686 "PresetList.c"
	}
}


static void
_vala_noise_preset_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PRESET_LIST, NoisePresetList);
#line 29 "../src/Widgets/PresetList.vala"
	switch (property_id) {
#line 1701 "PresetList.c"
		default:
#line 29 "../src/Widgets/PresetList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1707 "PresetList.c"
	}
}



